package com.steerinfo.baseinfo.meterbaseversions.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbaseversions.model.MeterBaseVersions;
import com.steerinfo.baseinfo.meterbaseversions.service.IMeterBaseVersionsService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterBaseVersions RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-08 03:59
 * 类描述
 * 修订历史：
 * 日期：2022-03-08
 * 作者：generator
 * 参考：
 * 描述：MeterBaseVersions RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseversionss")
public class MeterBaseVersionsController extends BaseRESTfulController {

    @Autowired
    IMeterBaseVersionsService meterBaseVersionsService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseversions:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseVersions> list = meterBaseVersionsService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseversions:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseVersions> list = meterBaseVersionsService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseVersions对象创建")
    @ApiImplicitParam(name = "meterBaseVersions", value = "详细实体meterBaseVersions", required = true, dataType = "MeterBaseVersions")
    //@RequiresPermissions("meterbaseversions:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseVersions model){
        try{
            RESTfulResult rm = meterBaseVersionsService.checkAdd(model);
            if (com.steerinfo.util.StringUtils.isEmpty(rm.getMessage())) {
                return  failed(null,rm.getMessage());
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseversions:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseVersions meterBaseVersions = meterBaseVersionsService.getById(id);
        return success(meterBaseVersions);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseVersions信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseVersions", value = "详细实体meterBaseVersions", required = true, dataType = "MeterBaseVersions")
    })
    //@RequiresPermissions("meterbaseversions:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseVersions model){
        model.setId(id);
        MeterBaseVersions meterBaseVersions = meterBaseVersionsService.modify(model);
        return success(meterBaseVersions);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseversions:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseVersionsService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="添加APP版本对象", notes="添加APP版本对象")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseVersions", value = "详细实体meterBaseVersions", required = true, dataType = "MeterBaseVersions")
    })
    @PostMapping(value = "checkAdd")//String
    public RESTfulResult checkAdd(@RequestBody MeterBaseVersions model){
        RESTfulResult rm = failed();
        rm = meterBaseVersionsService.checkAdd(model);
        return rm;
    }

    @ApiOperation(value="根据版本编号返回最新的APP版本对象", notes="根据版本编号返回最新的APP版本对象")
    @PostMapping(value = "selectByVersionNo")//String
    public RESTfulResult selectByVersionNo(@RequestParam String versionNo){
        RESTfulResult rm = failed();
        if(com.steerinfo.util.StringUtils.isEmpty(versionNo)){
            rm.setMessage("版本编号不能为空！！");
            return rm;
        }
        rm = meterBaseVersionsService.selectByVersionNo(versionNo);
        return rm;
    }

    @ApiOperation(value="根据版本编号废除版本信息", notes="根据url的versionNo废除指定对象")
    @PostMapping(value = "updateValueFlag")//String
    public RESTfulResult updateValueFlag(@RequestParam String versionNo){
        RESTfulResult rm = failed();
        if(com.steerinfo.util.StringUtils.isEmpty(versionNo)){
            rm.setMessage("版本编号不能为空！！");
            return rm;
        }
        rm = meterBaseVersionsService.updateValueFlag(versionNo);
        return rm;
    }
}
